import { colors } from './colors';

export const nodes = [];
export const links = [];

const MAIN_NODE_SIZE = 70;
const CHILD_NODE_SIZE = 60;
const LEAF_NODE_SIZE = 5;
const DEFAULT_DISTANCE = 20;
const MAIN_NODE_DISTANCE = 90;
const LEAF_NODE_DISTANCE = 30;
export const MANY_BODY_STRENGTH = -20;

let i = 0;

const addMainNode = (node) => {
  node.size = MAIN_NODE_SIZE;
  node.color = colors[i++][1];
  nodes.push(node);
};

const addChildNode = (
  parentNode,
  childNode,
  size = CHILD_NODE_SIZE,
  distance = 300
) => {
  childNode.size = size;
  childNode.color = colors[i++][1];
  nodes.push(childNode);
  links.push({
    source: parentNode,
    target: childNode,
    distance,
    color: childNode.color,
  });
};

const assembleChildNode = (parentNode, id, numLeaves = 0) => {
  const childNode = { id };
  addChildNode(parentNode, childNode);
  

  for (let i = 0; i < numLeaves; i++) {
    addChildNode(childNode, { id: '' }, LEAF_NODE_SIZE, LEAF_NODE_DISTANCE);
  }
};

const connectMainNodes = (source, target) => {
  links.push({
    source,
    target,
    distance: MAIN_NODE_DISTANCE,
    color: source.color
  });
};

const artsWeb = { id: 'NIKHIL' };
addMainNode(artsWeb);
assembleChildNode(artsWeb, 'SUMANTH');
assembleChildNode(artsWeb, 'NISHITH');
